/*
 * Jalview - A Sequence Alignment Editor and Viewer ($$Version-Rel$$)
 * Copyright (C) $$Year-Rel$$ The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.ws.uimodel;

/**
 * configures annotation worker style web service clients
 * 
 * @author jprocter
 *
 */
public class AlignAnalysisUIText
{

  private String serviceType;

  public String getServiceType()
  {
    return serviceType;
  }

  private Class client;

  private String calcId;

  public String getCalcId()
  {
    return calcId;
  }

  private String AAconToggle, AAconToggleTooltip, AAeditSettings,
          AAeditSettingsTooltip;

  private boolean isNa;

  public boolean isNa()
  {
    return isNa;
  }

  public boolean isPr()
  {
    return isPr;
  }

  /**
   * @return true if service can accept sequences with gaps
   */
  public boolean isAA()
  {
    return isAA;
  }

  private boolean isPr;

  private boolean isAA;

  private boolean filterSymbols;


  private boolean needsAlignedSeqs;

  private int min_valid_seqs;


  public AlignAnalysisUIText(String serviceType, Class<?> client,
          String calcId, boolean acceptNucl, boolean acceptProt,
          boolean acceptGaps, boolean alignedSeq,
          boolean filterNonStandardSymbols, int minSeq, String toggle,
          String toggleTooltip,
          String settings, String settingsTooltip)
  {
    this.serviceType = serviceType;
    this.calcId = calcId;
    isNa = acceptNucl;
    isPr = acceptProt;
    isAA = acceptGaps;
    this.needsAlignedSeqs = alignedSeq;
    this.filterSymbols = filterNonStandardSymbols;
    this.client = client;
    this.AAconToggle = toggle;
    this.AAconToggleTooltip = toggleTooltip;
    this.AAeditSettings = settings;
    this.AAeditSettingsTooltip = settingsTooltip;
    this.min_valid_seqs = minSeq;
  }

  /**
   * 
   * @return true if non-standard nucleotides and amino acids should be replaced
   *         or omitted
   * 
   */
  public boolean isFilterSymbols()
  {
    return filterSymbols;
  }

  /**
   * 
   * @return true if service needs sequences all the same length (ie padded with
   *         gaps if necessary)
   */
  public boolean isNeedsAlignedSeqs()
  {
    return needsAlignedSeqs;
  }

  public Class getClient()
  {
    return client;
  }

  public void setClient(Class client)
  {
    this.client = client;
  }

  public String getAAconToggle()
  {
    return AAconToggle;
  }

  public void setAAconToggle(String aAconToggle)
  {
    AAconToggle = aAconToggle;
  }

  public String getAAconToggleTooltip()
  {
    return AAconToggleTooltip;
  }

  public void setAAconToggleTooltip(String aAconToggleTooltip)
  {
    AAconToggleTooltip = aAconToggleTooltip;
  }

  public String getAAeditSettings()
  {
    return AAeditSettings;
  }

  public void setAAeditSettings(String aAeditSettings)
  {
    AAeditSettings = aAeditSettings;
  }

  public String getAAeditSettingsTooltip()
  {
    return AAeditSettingsTooltip;
  }

  public void setAAeditSettingsTooltip(String aAeditSettingsTooltip)
  {
    AAeditSettingsTooltip = aAeditSettingsTooltip;
  }

  public int getMinimumSequences()
  {
    return min_valid_seqs;
  }

}
